// JVM looks for values in Heap.
import java.lang.Object;
class Main {

    public static void main(String[] args) {

        // Part 1. String literal and String Object.
        // if two JVM see a String with the same value
        // it won't create a new object.

        // String literal
        String myStr = "Hello World";
        String myStr2 = "Hello World";
        System.out.println(myStr);
        System.out.println(myStr2);

        // Printing out both String object's hashcode (same)
        System.out.println(myStr.hashCode());
        System.out.println(myStr2.hashCode());

        // Compare string literals
        // == checks if both objects point to the same memory.
        // equals() checks value
        System.out.println(myStr == myStr2);
        System.out.println(myStr.equals(myStr2));

        // String with keyword
        String strObj = new String("Hello World");
        String strObj2 = new String("Hello World");

        // Compare string literal to string object
        System.out.println(myStr == strObj);
        System.out.println(myStr.equals(strObj));

        // Print out both String object's hashcode (different)
        System.out.println(strObj.hashCode());
        System.out.println(strObj2.hashCode());

        // Compare strings with keyword;
        System.out.println(strObj == strObj2);
        System.out.println(strObj.equals(strObj2));

        // Part 2. Compare using compareTo() method

        // 0 on equal
        // > 0 on obj1 has more chars than obj2
        // < 0 on obj1 has more chars than obj2
        System.out.println(myStr.compareTo(myStr2));
        System.out.println(strObj.compareTo(strObj2));

/*        // Part 3. StringBuffer and StringBuilder

        StringBuffer strBuff = new StringBuffer("Java is an Object Oriented Language");
        StringBuilder strBuild = new StringBuilder("Java is an Object Oriented Language");

        StringBuffer iterBuff = new StringBuffer();
        StringBuilder iterBuilder = new StringBuilder();

        System.out.println(strBuff);
        System.out.println(strBuild);

        long start = System.nanoTime();

        for (int i = 0; i < strBuff.length(); i++) {
            iterBuff.append(strBuff.charAt(i));
        }
        long end = System.nanoTime();
        long elapsedTime = end - start;
        System.out.println(elapsedTime);

        long start1 = System.nanoTime();

        for (int i = 0; i < strBuild.length(); i++) {
            iterBuilder.append(strBuild.charAt(i));
        }
        long end1 = System.nanoTime();
        long elapsedTime1 = end1 - start1;
        System.out.println(elapsedTime1);

        // Part 4. String toUpperCase()
        String strLow = new String("String to Uppercase");
        String strUp = strLow.toUpperCase();
        System.out.println(strUp);*/

        // Part 5. isPrime method
//
//        System.out.println(isPrime(12));
//        System.out.println(upperString("My Name is abc"));
    }
    static int isPrime(int x) {
        int count = 0;
        for(int i = 1; i < x; i++) {
            if (x % i == 0) {
                count++;
            }
        }
        return count;
    }

    static StringBuilder upperString(String s) {
        StringBuilder capStr = new StringBuilder();
        for(int i = 0; i < s.length(); i++) {
            int a = s.charAt(i);
            System.out.println(a);

            if(a < 90){
                capStr.append(s.charAt(i));
                continue;
            }

            a = a - 32;
            // Type Casting
            char ss = (char) a;
            capStr.append(ss);
        }
        return capStr;
    }
}